=== debian/changelog ===
gnss-sdr (0.0.10-4) unstable; urgency=medium

  * Apply patch to deactivate problematic tests from the building stage

 -- Carles Fernandez <carles.fernandez@cttc.es>  Sat, 09 Feb 2019 12:35:25 +0100

gnss-sdr (0.0.10-3) unstable; urgency=medium

  * Standards-Version updated to 4.2.1
  * Apply patch for building tests (Closes: bug#918055)

 -- Carles Fernandez <carles.fernandez@cttc.es>  Fri, 08 Feb 2019 12:19:52 +0100

gnss-sdr (0.0.10-2) unstable; urgency=medium

  * Team upload.
  * Set HOME to debian/home so the testsuite can create ~/.gnuradio/.

 -- Christoph Berg <myon@debian.org>  Sun, 30 Dec 2018 15:38:38 +0100

gnss-sdr (0.0.10-1) unstable; urgency=medium

  * First release of upstream version 0.0.10
  * Standards-Version updated to 4.2.1
  * Updated compat level to 11
  * Updated Vcs links to Salsa servers, completing Alioth to Salsa migration
  * Added autopkgtest check
  * Added debian/upstream/metadata file
  * Added libpcap-dev as a new dependency for UDP streaming of signal samples
  * Added libiio-dev and gr-iio as new dependencies for using with AD front-ends
  * Added libmatio-dev for storing data in .mat format
  * Added libpugixml-dev dependency for XML file handling
  * Switched back from googletest to libgtest-dev dependency
  * Switched from python-mako and python-six to their python3 counterparts
  * Switched from http to https for project homepage
  * Updated copyright file for new contributions by Alvaro Cebrian, Antonio
    Ramos, Cillian O'Driscoll, Damian Miralles, Gabriel Araujo, Rodrigo Muñoz
    Lazo, T. Takasu, Phil Karn, Jeremy Conlin and Swift Navigation Inc.
  * Added LGPL-3+ license text for files under src/algorithms/libs/rtklib/
  * Added -DENABLE_FMCOMMS2=ON, -DENABLE_PLUTOSDR=ON, -DENABLE_AD9361=ON and
    -DENABLE_RAW_UDP=ON building options in debian/rules
  * Fix building with boost 1.67 (Closes: bug#911882)

 -- Carles Fernandez <carles.fernandez@cttc.es>  Fri, 14 Dec 2018 19:37:40 +0100
